from graphics import *
from math import *

longueur = 200
hauteur = 200
x_min = -2
x_max = 1
y_min = -1.5
y_max = 1.5

fenetre = GraphWin(width = longueur, height = hauteur) 
fenetre.setCoords(0, 0, longueur, hauteur) # bottom left is (0, 0) and top right is (1000, 800)

def pixel2z(i,j):
    # transforme un pixel en un couple (Re, Im)
    return([x_min+i*(x_max-x_min)/longueur,y_min+j*(y_max-y_min)/hauteur])

def sommeC(z1,z2):
    return([z1[0]+z2[0],z1[1]+z2[1]])

def produitC(z1,z2):
    return([z1[0]*z2[0]-z1[1]*z2[1],z1[0]*z2[1]+z1[1]*z2[0]])

def moduleC(z):
    return(sqrt(z[0]**2+z[1]**2))

def mandelbrot(max_iter):
    for i in range(longueur):
        for j in range(hauteur):
            c=pixel2z(i,j)
            z=[0,0]
            iter=0
            while iter<max_iter and (z[0]**2+z[1]**2)<4:
                z=sommeC(produitC(z,z),c)
                iter += 1
            pt = Point(i,j)
            if iter==max_iter:
                pt.setOutline(color_rgb(0,0,0))
            else:
                pt.setOutline(color_rgb(255-floor(iter/100*255),0,0))
            pt.draw(fenetre)

mandelbrot(100)

fenetre.getMouse() # pause avant fermeture
