from graphics import *
from math import *

longueur = 2000
hauteur = 1400
x_min = -3.14
x_max = 6.28
y_min = -1.5
y_max =2

fenetre = GraphWin(width = longueur, height = hauteur) 
fenetre.setCoords(0, 0, longueur, hauteur) # bottom left is (0, 0) and top right is (1000, 800)
un_rectangle = Rectangle(Point(2, 2), Point(longueur-2, hauteur-2))
un_rectangle.setFill('white')
un_rectangle.draw(fenetre)

def transfo(x,y):
    # transforme un couple de réel en un pixel de coordonnées convenables
    return(Point(floor((x-x_min)/(x_max-x_min)*longueur),floor((y-y_min)/(y_max-y_min)*hauteur)))

def axe_x(val):
    # trace un axe horizontal de la forme y=val
    pt_1 = transfo(x_min,val)
    pt_2 = transfo(x_max,val)
    line = Line(pt_1, pt_2)
    line.draw(fenetre)

def axe_y(val):
    #trace un axe vertical de la forme x=val
    pt_1 = transfo(val,y_min)
    pt_2 = transfo(val,x_max)
    line = Line(pt_1, pt_2)
    line.draw(fenetre)

def f(x):
    return(sin(x))

def trace_fonction(nb,r,g,b):
    # nombre de points à tracer, de couleur red, green, blue
    for j in range(nb):
        x=x_min+j*(x_max-x_min)/nb
        pt = transfo(x,f(x))
        pt.setOutline(color_rgb(r,g,b))
        pt.draw(fenetre)

def tangente(a,r,g,b):
    # trace la tangente au point a entre a-pas et a+pas
    pas=2
    pt_1 = transfo(a-pas,sin(a)+(-1)*pas*cos(a))
    pt_2 = transfo(a+pas, sin(a)+pas*cos(a))
    line = Line(pt_1, pt_2)
    line.setOutline(color_rgb(r,g,b))
    line.draw(fenetre)

def enveloppe(nbre):
    for i in range(1,nbre):
        tangente(x_min+i*(x_max-x_min)/nbre,floor((nbre-i)/nbre*255),0,255-floor((nbre-i)/nbre*255))
        time.sleep(.1)

axe_x(0)
axe_y(0)
trace_fonction(3000,255,0,0)

fenetre.getMouse() # pause, attend un clic

enveloppe(200)

fenetre.getMouse() # pause avant fermeture
